require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/cities', type: :request do
  # This should return the minimal set of attributes required to create a valid
  # City. As you add validations to City, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) do
    {
      name: 'London',
      latitude: 51.50722,
      longitude: -0.1275,
      demonym: 'Londoners',
      website: 'https://www.london.gov.uk/'
    }
  end

  let(:invalid_attributes) do
    {
      name: '',
      latitude: 0,
      longitude: 0,
      demonym: '',
      website: ''
    }
  end

  # This should return the minimal set of values that should be in the headers
  # in order to pass any filters (e.g. authentication) defined in
  # CitiesController, or in your router and rack
  # middleware. Be sure to keep this updated too.
  let(:valid_headers) do
    {}
  end

  describe 'GET /index' do
    it 'renders a successful response' do
      City.create! valid_attributes
      get cities_url, headers: valid_headers, as: :json
      expect(response).to be_successful
    end
  end

  describe 'GET /show' do
    it 'renders a successful response' do
      city = City.create! valid_attributes
      get city_url(city), as: :json
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new City' do
        expect do
          post cities_url,
               params: { city: valid_attributes }, headers: valid_headers, as: :json
        end.to change(City, :count).by(1)
      end

      it 'renders a JSON response with the new city' do
        post cities_url,
             params: { city: valid_attributes }, headers: valid_headers, as: :json
        expect(response).to have_http_status(:created)
        expect(response.content_type).to match(a_string_including('application/json'))
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new City' do
        expect do
          post cities_url,
               params: { city: invalid_attributes }, as: :json
        end.to change(City, :count).by(0)
      end

      it 'renders a JSON response with errors for the new city' do
        post cities_url,
             params: { city: invalid_attributes }, headers: valid_headers, as: :json
        expect(response).to have_http_status(:unprocessable_entity)
        expect(response.content_type).to match(a_string_including('application/json'))
      end
    end
  end
end
